; ===========================================================
;
#define base_n1
;#define base_n2
;#define base_n16
;
; ===========================================================
;
manACC	.equ $406A		; 16490: MEMBOT+13
expACC	.equ $406F		; 16495: MEMBOT+18
manBCD	.equ $4070		; 16496: MEMBOT+19
expBCD	.equ $4075		; 16501: MEMBOT+24

;	.org $40a2		; in case of prfp_tst

	rst 28h		; FP-CALC	A.
	.db $A0         ;;stk-zero	A, 0.
	.db $C4		;;set-mem-4	A, 0.
	.db $C3		;;set-mem-3	A, 0.
	.db $02		;;delete	A.
	.db $C0		;;set-mem-0	A.
	.db $02		;;delete	.
	.db $34		;;end-calc

	ld a,(de)		; test the exponent
	and a			; if it is zero, then return via
	jp z,$07EB		; routine OUT-CODE (prints a zero)

	ld hl,$405E		; first byte of the mantissa (MEMBOT+1)
	bit 7,(hl)		; test if nagative
	set 7,(hl)		; complete the mantissa
	jr z,positive		; skip if positive

	ld a,$16		; else load code '-'
	rst 10h			; PRINT-A
positive
;	==========================================================
;
#ifdef base_n1

	ld hl,baseNum1		; select value of the lsb (bit)
	ld de,manACC		; points the BCD accumulator

#else	;	--------------------------------------------------

	dec l			; points the binary exponent

#ifdef base_n2	;	------------------------------------------
 
	ld a,(hl)		; value of the exponent
	ex de,hl		; save the pointer in DE
	ld hl,baseNum1		; select the lsb (bit) value

	sub $71			; x < 2^-16 ?
	jr c,load_lsb		; if yes, then jump to load BCD nr.

	inc a			; else
	ld (de),a		; choose another
	ld hl,baseNum2		; value for the lsb (bit)
load_lsb
	ld e,manACC		; points the BCD accumulator

#else	;	--------------------------------------------------

	dec (hl)		; [$01..$FF] -> [$00..$FE]
	xor a			;
	rrd			; fetch lower nible
	ld c,(hl)		; fetch upper nible
	inc a			; [$00..$0E] -> [$01..$0F]
	ld (hl),a		; store lower nible

	ld hl,baseNum1		; points the 1st BCD nr.
	ld a,c			; the upper nible [$00..$0F]
	add a,a			; 2*
	add a,c			; 3*
	add a,a			; 6*
	ld c,a			;
	add hl,bc		; set pointer

	ld de,manACC		; points the BCD accumulator
#endif
	;	--------------------------------------------------
#endif	
;	==========================================================
;
	ld bc,5			; set counter
	ldir			; copy 10 digits of the BCD mantissa
	ld a,(hl)		; and the BCD exponent
	ld (de),a		; to the BCD accumulator
	ld (expBCD),a		; and to the BCD number

	ld c,4			; length of the binary mantissa
	ld hl,$4061		; the LSB of the binary mantissa
;
;	--------------------------------------------------
BCD_loop
	ld b,8			; set the bit counter
bit_loop
	push bc			; save counters
	rr (hl)			; set CY
	push hl			; save pointer

	call c,set_BCD		; add the BCD accu. to the BCD value

	ld e,expACC		; set both pointers to
	ld l,e			; BCD accumulator
	call add_BCD		; *2

	pop hl			; restore pointer
	pop bc			; restore counters
	djnz bit_loop		; last bit in the byte?

	dec l			; points the next byte
	dec c			; last byte of the mantissa?
	jr nz,BCD_loop		; back if not
;
;	--------------------------------------------------
;
finish
	ld e,expBCD		; set both pointers
	ld l,e			; to BCD value

	call add_BCD		; *2

	dec (iy+$5D)		; test the 'original' exponent
	jr nz,finish		; back, if it is not zero
;
;	--------------------------------------------------
digits8
	xor a			; clear A and CY
	call shr_BCD		; shift right and rounding

	jr nz,digits8		; is it 8-digit BCD? (A: $00)
;
;	--------------------------------------------------
;
	ld bc,$0801		; 8 digits to print, decimal
				; point is after the first
	ld e,c			; e=1 (not e-format)
				; 
	ld l,expBCD		; the BCD exponent
cnt_zero
	dec l			; points 2 digits of the mantissa 
	dec b			; decrease the counter of
	dec b			; the nonzero digits
	ld a,(hl)		; read in and
	and a			; test 2 digits of the mantissa
	jr z,cnt_zero		; if zero then check next 2 digits

	inc b			; else increase the digit counter
	and $0f			; mask out the lower digit
	jr z,chk_sexp		; if zero then fwd. to test exp.

	inc b			; else increase the digit counter
chk_sexp
	ld a,(expBCD)		; test the BCD exponent
	bit 7,a			; positive?
	jr z,pos_exp		; yes, jump
;
;	--------------------------------------------------
;
	neg			; make it positive
	cp $05			; less than .0001?
	jr nc,neg_exp		; yes -> e-format
;
;	--------------------------------------------------
;
	ld d,a			; nr. of leading zeros

	add a,b			; increase and
	ld b,a			; save nr. of printable digits
leadzero	
	xor a			; print
	call pr_digit		; leading
	dec d			; zeros
	jr nz,leadzero		; done?

	jr not_efmt		; forward to printing the rest
;
;	--------------------------------------------------
;
pos_exp
	cp $08			; more than 99999999?
	jr nc,e_format		; yes, e-format

	add a,c			; set position of
	ld c,a			; the decimal point
	cp b			; if nr. of the printable digits
	jr c,not_efmt		; is greater than position of the
				; decimal point then forward
	ld b,c			; else set nr. of printable digits
	jr not_efmt		; to decimal point position
;
;	--------------------------------------------------
neg_exp
	inc e			; the exponent is negative
;
;	--------------------------------------------------
e_format
	ld d,a			; save value of the exponent
	inc e			; set e-format (e>1)
;
;	--------------------------------------------------
not_efmt
	ld l,manBCD		; HL points the BCD mantissa
e_form1
	inc l			; point the next 2 digits
	call prDigits		; display digit(s)

	jr nz,e_form1		; back until done
print_E
	dec e			; e-format (e>1) ?
	ret z			; no, done

	dec c			; decimal point

	ld a,$2A		; else
	rst 10h			; print 'E'

	ld a,$15		; load '+' 
	dec e			;
	add a,e			;
	rst 10h			; PRINT-A
;
;	--------------------------------------------------
;
 	ld a,d			; get value of the exponent
set_E1
	ld d,a			; save as ones
	sub 10			; decrease by 10
	jr c,set_E2		; until negative

	djnz set_E1		; count tens
set_E2	
	xor a			; the counter of tens is negative
	sub b			; make it positive, then
	call nz,pr_digit	; print if nonzero

 	ld a,d			; the ones
	jr pr_digit		; print 
;
;	--------------------------------------------------
prDigits
	call prNibble		; print the upper nibble
	ret z			; return if it was the last
prNibble
	xor a			; else get
	rld			; a digit
pr_digit
	add a,$1C		; offset
	rst 10h			; print
	dec b			; was it the last digit?
	ret z			; yes return

	dec c			; decimal point?
	ret nz			; no, return

	ld a,$1B		;'.'
	rst 10h			; print
	ret			;
;
;	--------------------------------------------------
div_ten
	xor a			; else clear A and CY
	inc l			; points the MSB of the BCD mantissa
	call shr_BCD		; shift right and round
;
;	--------------------------------------------------
set_BCD
	ld e,expBCD		; points the expoonent of BCD value
exp_test
	ld l,expACC		; the expoonent of the BCD accumulator
	ld a,(de)		; compare
	cp (hl)			; them
	jr nz,div_ten		; back if there is difference
;
;	--------------------------------------------------
;	de: BCD_exponent of the operand 1 (the destination)
;	hl: BCD_exponent of the operand 2
add_BCD
	xor a			; clear A and CY
	ld b,5			; length of the BCD mantissa
adc_next
	dec e			; set OP1 pointer
	dec l			; set OP2 pointer
	ld a,(de)		; A=op1 byte
	adc a,(hl)		; A=op1 byte+op2 byte
	daa			; BCD correction
	ld (de),a		; save as op1 byte
	djnz adc_next		; last byte of the BCD mantissa?
	ld l,e			; HL=DE (points OP1)
	ret nc			; return if not overflow
;
;	--------------------------------------------------
;
	ld a,1			; else insert 1 and shift digits
shr_BCD
	ld bc,$0505		; length of the BCD mantissa
rrd_BCD
	rrd			; shift digits
	inc l			; the next byte
	djnz rrd_BCD		; last byte of the BCD mantissa?

	inc (hl)		; set the BCD_exponent: +1
	cp c			; if rounding is necessary
	ccf			; then CY is set
;
;	--------------------------------------------------
;
	ld b,c			;  length of the BCD mantissa
roundBCD
	dec l			; set pointer
	ld a,0			; clear A
	adc a,(hl)		; add the CY
	daa			; BCD correction
	ld (hl),a		; store the result
	djnz roundBCD		; last byte of the BCD mantissa?
	
	ret			; done
;
;	--------------------------------------------------
baseNum1
	.db $68,$42,$27,$76,$58,-51	; 2^-160 : 6.842277658E-49

#ifdef base_n16

	.db $44,$84,$15,$50,$86,-46	; 2^-144 : 4.484155086E-44
	.db $29,$38,$73,$58,$77,-41	; 2^-128 : 2.938735877E-39
	.db $19,$25,$92,$99,$44,-36	; 2^-112 : 1.925929944E-34
	.db $12,$62,$17,$74,$48,-31	; 2^-96  : 1.262177448E-29
	.db $82,$71,$80,$61,$26,-27	; 2^-80  : 8.271806126E-25
	.db $54,$21,$01,$08,$62,-22	; 2^-64  : 5.421010862E-20
#endif
#ifndef base_n1
baseNum2
	.db $35,$52,$71,$36,$79,-17	; 2^-48  : 3.552713679E-15
#endif
#ifdef base_n16

	.db $23,$28,$30,$64,$37,-12	; 2^-32  : 2.328306437E-10
	.db $15,$25,$87,$89,$06, -7	; 2^-16  : 1.525878906E-05
	.db $10,$00,$00,$00,$00, -2	; 2^0	 : 1.000000000E+00
	.db $65,$53,$60,$00,$00,  2	; 2^+16  : 6.553600000E+04
	.db $42,$94,$96,$72,$96,  7	; 2^+32  : 4.294967296E+09
	.db $28,$14,$74,$97,$67, 12	; 2^+48  : 2.814749767E+14
	.db $18,$44,$67,$44,$07, 17	; 2^+64  : 1.844674407E+19
	.db $12,$08,$92,$58,$20, 22	; 2^+80  : 1.208925820E+24
#endif
;
; ===========================================================
