; ===========================================================
;
;#define MULTEN_10
#define MULTEN_28
;
; ===========================================================

	.org $40a2		; in case of prfp_tst

	rst 28h		; FP-CALC	A.
	.db $C0		;;set-mem-0	A.
	.db $02		;;delete	.	clear the
	.db $34		;;end-calc		calc. stack

	ld a,(de)		; pick up the exponent byte
	and a			; if it is zero, then return via
	jp z,$07EB		; routine OUT-CODE (prints a zero)

	call $151D		; routine STACK-A places on calculator stack.

	ld hl,$405E		; first byte of the mantissa (MEMBOT+1)
	bit 7,(hl)		; test if positive
	set 7,(hl)		; complete the mantissa (make it nagative)
	jr z,positive		; skip if positive

	ld a,$16		; load code '-'
	rst 10h			; PRINT-A
positive
	ld l,$67		; set pointer to MEMBOT+10 (mem2: $4067)
	push hl			; save pointer (of the digit buffer)

	rst 28H		;; FP-CALC		e	[1..255]

        .db $30, $EF		;; stk-data, exponent: $7F, bytes: 4
        .db $9A,$20,$9A,$84	;;		e, -0.30103 (-log 2)

        .db $04		;; multiply		e*(-log 2)

	.db $30, $36	;; stk-data exponent:	$86, Bytes: 1
	.db $1C		;; (+00,+00,+00)	e*(-log 2), 39

	.db $0F		;; addition		e*(-log 2)+39

	.db $C2		;; st-mem-2		exp10.
	.db $E0		;; get-mem-0		exp10, x.
	.db $E2		;; get-mem-2		exp10, x, exp10.

	.db $38		;; e-to-fp		exp10,x * (10^exp10).
	.db $34		;; end-calc

;	call L155A		; new e-to-fp: x * (10^exp10).
;
;	---------------------------------------------
;
	ld bc,$0900		; B: 9 digits to convert
				; C: exp10 factor (0 by default)
	ld a,(hl)		; test the normalized number
	sub $81			; >=1?
	jr nc,nonZero		; skip if yes

	dec c			; else set factor to -1
nonZero
	push bc			; save counter/factor

#IFDEF MULTEN_10

	jr c,mul_ten		; if <1, then multiply by 10
#ELSE
	jr c,mul_ten2		; if <1, then multiply by 10
#ENDIF
;
;	---------------------------------------------
getDigit
	inc a			; exp-$80 gives the
	ld c,a			; bit counter of a digit
	xor a			; clear CY and the bit buffer
nxt_mbit
	call mb_loop		; shift left the mantissa

	rla			; store 1 bit of the digit
	dec c			; set bit counter
	jr nz,nxt_mbit		; done? -> back if not
putDigit
	pop bc			; restore counter/factor
	ex (sp),hl		; switch pointers
	ld (hl),a		; put digit into buffer
	inc hl			; set buffer pointer
	ex (sp),hl		; switch back pointers

	dec b			; set the digit counter
	push bc			; save counter/factor
	jr z,dig9done		; done if it was the 9th digit
test_msb
	inc hl			; else normalize the number
	bit 7,(hl)		; test the msb of the mantissa
	jr nz,mul_ten		; back if it is nonzero

	call mb_loop		; shift left the mantissa
	jr test_msb		;
;
;	---------------------------------------------
mul_ten

#IFDEF MULTEN_10

	rst 28H		;; FP-CALC
	.db $A4		;;stk-ten	x, 10.
	.db $04		;;multiply	x*10.
	.db $34		;;end-calc
#ELSE
	dec hl			; points the exponent
mul_ten2
	inc (hl)		; *2

	rst 28H		;; FP-CALC
	.db $2D		;;duplicate	2*x, 2*x.
	.db $34		;;end-calc

	inc (hl)		; 4*x
	inc (hl)		; 8*x

	rst 28H		;; FP-CALC
	.db $0F		;; addition	10*x
	.db $34		;;end-calc
#ENDIF
	ld a,(hl)		;
	sub $81			;
	jr nc,getDigit		;

	xor a			;
	jr putDigit		;
;
;	---------------------------------------------
dig9done
	rst 28H		;; FP-CALC	-exp10,final x.
	.db $02		;;delete	-exp10.
	.db $34		;;end-calc	-exp10.

	call $15CD		; FP-TO-A (-exp10) : A=abs(exp10)
	jr nz,negative		; if it is positive

	neg			; then make it negative
negative
	pop bc			; get the exp10 factor (0 or -1)
	add a,c			; and add to the exp10

	pop hl			; get the buffer pointer
	dec hl			; points the 9th digit
	push af			; save the final exp10
;
;	---------------------------------------------
rounding
	push hl			; save the buffer pointer
	ld a,4			; test the last digit (>=5?)
	sub (hl)		; CY=1 if rounding is necessary
	ld b,8			; set the digit counter
round_8
	dec hl			; set buffer pointer
	ld a,(hl)		; pick up the next digit
	adc a,$90		; add the rounding bit
	daa			; BCD correction
	jr c,overflow		; jump if overflow

	and $0F			; else clear the upper nibble
overflow
	ld (hl),a		; store the digit
	djnz round_8		; done? -> back if not

	jr nc,cnt_zero		; jump if no overflow

	pop hl			; get pointer of the 9th digit
	pop af			; <- exp10
	inc a			; exp10 +1
	push af			; exp10 ->
	push hl			; save pointer
	ld d,h			; set the
	ld e,l			; destination pointer
	dec hl			; 8th digit
	ld c,8			; set counter
	lddr			; copy
	
	inc hl			; HL points the first digit
	ld (hl),1		; set as '1'
	pop hl			; restore the buffer pointer
	jr rounding		; back to rounding check
;
;	---------------------------------------------
cnt_zero
	pop hl			; points the 9th digit
	pop de			; D <- exp10
;
;	--------------------------------------------------
;
	ld bc,$0901		; 8 digits to print, decimal
				; point is after the first
	ld e,c			; e=1 (not e-format)
cnt_back
	dec l			; points a digit of the mantissa 
	dec b			; decrease the counter of
	ld a,(hl)		; read in and
	and a			; test 2 digits of the mantissa
	jr z,cnt_back		; if zero then check next digit

	ld a,d			; test the exp10
	bit 7,a			; positive?
	jr z,pos_exp		; yes, jump
;
;	--------------------------------------------------
;
	neg			; make it positive
	cp $05			; less than .0001?
	jr nc,neg_exp		; yes -> e-format
;
;	--------------------------------------------------
;
	ld d,a			; nr. of leading zeros
	add a,b			; increase and
	ld b,a			; save nr. of printable digits
leadzero	
	xor a			; print
	call pr_digit		; leading
	dec d			; zeros
	jr nz,leadzero		; done?

	jr not_efmt		; forward to printing the rest
;
;	--------------------------------------------------
;
pos_exp
	cp $08			; more than 99999999?
	jr nc,e_format		; yes, e-format

	add a,c			; set position of
	ld c,a			; the decimal point
	cp b			; if nr. of the printable digits
	jr c,not_efmt		; is greater than position of the
				; decimal point then forward
	ld b,c			; else set nr. of printable digits
	jr not_efmt		; to decimal point position
;
;	--------------------------------------------------
neg_exp
	inc e			; the exponent is negative
;
;	--------------------------------------------------
e_format
	ld d,a			; save the exponent
	inc e			; set e-format (e>1)
;
;	--------------------------------------------------
not_efmt
	ld l,$67		; $4067 - the 1st digit
e_form1
	ld a,(hl)		; get value
	inc l			; set pointer
	call pr_digit		; display a digit

	jr nz,e_form1		; back until done
print_E
	dec e			; e-format (e>1) ?
	ret z			; no, done

	dec c			; decimal point

	ld a,$2A		; else
	rst 10h			; print 'E'

	ld a,$15		; load '+' 
	dec e			; if exp>0 then E=0
	add a,e			; else E=1 -> A: '-'
	rst 10h			; PRINT-A
;
;	--------------------------------------------------
;
 	ld a,d			; get value of the exponent
set_E1
	ld d,a			; save as ones
	sub 10			; decrease by 10
	jr c,set_E2		; until negative

	djnz set_E1		; count tens
set_E2	
	xor a			; the counter of tens is negative
	sub b			; make it positive, then
	call nz,pr_digit	; print if nonzero

 	ld a,d			; the ones
;
;	--------------------------------------------------
pr_digit
	add a,$1C		; offset (code of '0')
	rst 10h			; print
	dec b			; it was the last digit?
	ret z			; yes return

	dec c			; decimal point?
	ret nz			; no, return

	ld a,$1B		;'.'
	rst 10h			; print
	ret			;
;
;	---------------------------------------------
mb_loop
	ld b,4			; size of the mantissa
	ld h,d			; set pointer after the
	ld l,e			; LSB of the mantissa
	scf			; CY=1
nx_mbyte
	dec hl			; the last/prev. mantissa byte
	rl (hl)			; CY <- 76543210 <- CY
	djnz nx_mbyte		; done? back if not

	dec hl			; points the exponent
	dec (hl)		; decrease it
	ret			;
;	
; ===========================================================
