;
; -----------------------------------------------
; THE new 'E-FORMAT TO FLOATING POINT' SUBROUTINE
; -----------------------------------------------
; (Offset $38: 'e-to-fp')
; invoked from DEC-TO-FP.
; e.g. 2.3E4 is 23000.
; This subroutine evaluates x*E exp10 where exp10 is a positive or
; negative integer.
; On entry in the ZX81, the exponent (exp10) is the 'last value',
; and the floating-point decimal mantissa is beneath it.
;
;; new e-to-fp
;; E-TO-FP
L155A:
	call L158A		; routine FP-TO-BC - the exponent

	jr z,E_POSTV		; test the exponent's sign

	inc b			; if negative then B=1
E_POSTV
	and a			; if exponent is zero
	ret z			; then return
;
;; E-LOOP	now enter a loop
LOOP_E10
	push bc			; save exponent (and its sign)
	djnz E_MUL10		; in case of pos. exp. multiplication

	rst 28H		;; FP-CALC	x.
	.db $A4		;; stk-ten	x, 10.
	.db $05		;; division	x/10.
	.db $34		;; end-calc	new x.

	jr skip_mul		; skip multiplication
E_MUL10
	rst 28H		;; FP-CALC	x.
	.db $A4		;; stk-ten	x, 10.
	.db $04		;; multiply	x*10.
	.db $34		;; end-calc	new x.
skip_mul
	pop bc			; restore exponent (and its sign)
	dec c			; set counter
	jr nz,LOOP_E10		; loop while nonzero

	ret			;
;
;	===========================================================
prDigits
	call prNibble		; print the upper nibble
	ret z			; return if it was the last digit
prNibble
	xor a			; else get a
	rld			; digit
pr_Digit
	add a,$1C		; offset
	rst 10h			; print
	dec b			; was it the last digit?
	ret z			; yes return

	dec c			; decimal point?
	ret nz			; no, return

	ld a,$1B		;'.'
	rst 10h			; print
	ret			;
;
;	===========================================================
;
	.db $FF,$FF,$FF,$FF	; spare
;
;	===========================================================
