;
; -----------------------------------------------
; THE new 'E-FORMAT TO FLOATING POINT' SUBROUTINE
; -----------------------------------------------
; (Offset $38: 'e-to-fp')
; invoked from DEC-TO-FP and PRINT-FP.
; e.g. 2.3E4 is 23000.
; This subroutine evaluates x*E exp10 where exp10 is a positive or
; negative integer.
; On entry in the ZX81, the exponent (exp10) is the 'last value',
; and the floating-point decimal mantissa is beneath it.
;
;; new e-to-fp
;; E-TO-FP
L155A:
	call L158A		; routine FP-TO-BC - the exponent

	jr z,E_POSTV		; test the exponent's sign

	inc b			; if negative then B=1
	push bc			; save counter (exponent and its sign)

	rst 28H		;; FP-CALC	x.
	.db $A4		;; stk-ten	x, 10.
	.db $34		;; end-calc

	jr skip_mul		; restore counter (exponent and its sign)
E_POSTV
	and a			; if exponent is zero
	ret z			; then return
;
;; E-LOOP	now enter a loop
LOOP_E10
	push bc			; save counter (exponent and its sign)
	call mul_by10		; multiply by 10
skip_mul
	pop bc			; restore counter (exponent and its sign)
	dec c			; set counter
	jr nz,LOOP_E10		; loop while nonzero

	djnz E_END		; in case of pos. exp. return

	rst 28H		;; FP-CALC	else
	.db $05		;;division	x/10^exp10.
	.db $34		;;end-calc	new x.
E_END
	ret
;
; ========================================================
;
;	the new PRINT-FP calls this subroutine
mul_ten
	dec hl			; hl points the exponent
;
; ---------------------------------------------------
; the 'tricky' multiplication:  10x = 2x + 8x
;
mul_by10
	inc (hl)		; x = x*2

	push hl			; save OP1 pointer
	call MOVE_FP		; duplicate 

	inc (hl)		; 4*x
	inc (hl)		; 8*x

	ex de,hl		; de: OP2 pointer (8*x)
	pop hl			; hl: OP1 pointer (2*x)
	call L1755		; routine addition
				; new x = 2*x + 8*x   (=10*x)
;
; ----------------------------------------------------------------
; the next few commands are necessary for the new PRINT-FP routine
; (does not affect the new E-TO-FP routine)
;
	ld a,(hl)		; pick up the exponent
	sub $81			; test if >=1
	ret nc			; return if so

	ld a,0			; else clear A
	ret			;
